"""empty message

Revision ID: 90f041e667a5
Revises: bb20ac30a018
Create Date: 2024-11-07 14:18:11.582517

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa

import flou


# revision identifiers, used by Alembic.
revision: str = '90f041e667a5'
down_revision: Union[str, None] = 'bb20ac30a018'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('experiments_experiments',
    sa.Column('id', sa.Uuid(), server_default=sa.text('gen_random_uuid()'), nullable=False),
    sa.Column('index', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=255), nullable=False),
    sa.Column('description', sa.String(), nullable=False),
    sa.Column('inputs', flou.database.utils.JSONType(), nullable=False),
    sa.Column('outputs', flou.database.utils.JSONType(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=False),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('experiments_trials',
    sa.Column('id', sa.Uuid(), server_default=sa.text('gen_random_uuid()'), nullable=False),
    sa.Column('index', sa.Integer(), nullable=False),
    sa.Column('experiment_id', sa.Uuid(), nullable=False),
    sa.Column('name', sa.String(length=255), nullable=False),
    sa.Column('ltm_id', sa.Integer(), nullable=False),
    sa.Column('rollback_index', sa.Integer(), nullable=False),
    sa.Column('snapshot_index', sa.Integer(), nullable=False),
    sa.Column('inputs', flou.database.utils.JSONType(), nullable=False),
    sa.Column('outputs', flou.database.utils.JSONType(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=False),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=False),
    sa.ForeignKeyConstraint(['experiment_id'], ['experiments_experiments.id'], ),
    sa.ForeignKeyConstraint(['ltm_id'], ['ltm_ltms.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('experiments_trials')
    op.drop_table('experiments_experiments')
    # ### end Alembic commands ###
