"""empty message

Revision ID: 74105a812f10
Revises: a3563fe36f94
Create Date: 2024-11-14 11:25:05.611175

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa
from alembic_utils.pg_function import PGFunction
from sqlalchemy import text as sql_text

# revision identifiers, used by Alembic.
revision: str = '74105a812f10'
down_revision: Union[str, None] = 'a3563fe36f94'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    public_experiments_set_index = PGFunction(
        schema="public",
        signature="experiments_set_index()",
        definition='RETURNS trigger AS $$\n        BEGIN\n            NEW.index := COALESCE(\n                (SELECT MAX(index) FROM experiments_experiments), 0\n            ) + 1;\n            RETURN NEW;\n        END;\n        $$ LANGUAGE plpgsql'
    )
    op.replace_entity(public_experiments_set_index)

    public_trials_set_index = PGFunction(
        schema="public",
        signature="trials_set_index()",
        definition='RETURNS trigger AS $$\n        BEGIN\n            NEW.index := COALESCE(\n                (SELECT MAX(index) FROM experiments_trials WHERE experiment_id = NEW.experiment_id AND name = NEW.name), 0\n            ) + 1;\n            RETURN NEW;\n        END;\n        $$ LANGUAGE plpgsql'
    )
    op.replace_entity(public_trials_set_index)

    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    public_trials_set_index = PGFunction(
        schema="public",
        signature="trials_set_index()",
        definition='returns trigger\n LANGUAGE plpgsql\nAS $function$\n        BEGIN\n            NEW.index := COALESCE(\n                (SELECT MAX(index) FROM experiments_trials WHERE experiment_id = NEW.experiment_id), -1\n            ) + 1;\n            RETURN NEW;\n        END;\n        $function$'
    )
    op.replace_entity(public_trials_set_index)
    public_experiments_set_index = PGFunction(
        schema="public",
        signature="experiments_set_index()",
        definition='returns trigger\n LANGUAGE plpgsql\nAS $function$\n        BEGIN\n            NEW.index := COALESCE(\n                (SELECT MAX(index) FROM experiments_experiments), -1\n            ) + 1;\n            RETURN NEW;\n        END;\n        $function$'
    )
    op.replace_entity(public_experiments_set_index)
    # ### end Alembic commands ###
